%global git 8405cfa0a99cea36a3574200e7e0514ff3eaab60

Name:           php-fkooman-jwt
Version:        2.0.0
Release:        0.1%{?dist}
Summary:        JWT Library

License:        MIT
URL:            https://software.tuxed.net/php-jwt
%if %{defined git}
Source0:        https://git.tuxed.net/fkooman/php-jwt/snapshot/php-jwt-%{git}.tar.xz
%else
Source0:        https://software.tuxed.net/php-jwt/files/php-jwt-%{version}.tar.xz
Source1:        https://software.tuxed.net/php-jwt/files/php-jwt-%{version}.tar.xz.asc
Source2:        gpgkey-6237BAF1418A907DAA98EAA79C5EDD645A571EB2
%endif

BuildArch:      noarch

BuildRequires:  gnupg2
BuildRequires:  php-fedora-autoloader-devel
BuildRequires:  %{_bindir}/phpab
#    "require-dev": {
#        "phpunit/phpunit": "^7|^8"
#    },
BuildRequires:  phpunit8
#    "require": {
#        "ext-date": "*",
#        "ext-hash": "*",
#        "ext-json": "*",
#        "ext-openssl": "*",
#        "ext-sodium": "*",
#        "ext-spl": "*",
#        "paragonie/constant_time_encoding": "^2.2",
#        "php": ">= 7.2"
#    },
BuildRequires:  php(language) >= 7.2
BuildRequires:  php-date
BuildRequires:  php-hash
BuildRequires:  php-json
BuildRequires:  php-openssl
BuildRequires:  php-sodium
BuildRequires:  php-spl
BuildRequires:  php-composer(paragonie/constant_time_encoding)

#    "require": {
#        "ext-date": "*",
#        "ext-hash": "*",
#        "ext-json": "*",
#        "ext-openssl": "*",
#        "ext-sodium": "*",
#        "ext-spl": "*",
#        "paragonie/constant_time_encoding": "^2.2",
#        "php": ">= 7.2"
#    },
Requires:  php(language) >= 7.2
Requires:  php-date
Requires:  php-hash
Requires:  php-json
Requires:  php-openssl
Requires:  php-sodium
Requires:  php-spl
Requires:  php-composer(paragonie/constant_time_encoding)

Provides:  php-composer(fkooman/jwt) = %{version}

%description
This is small JSON Web Token implementation. It only supports signatures 
with the following signature algorithms:

* HS256 (HMAC using SHA-256)
* RS256 (RSASSA-PKCS1-v1_5 using SHA-256)
* EdDSA (Ed25519, RFC 8037)

The first two seem to be the most widely deployed JWT signature algorithms. 
The library does NOT support encryption/decryption due to the can of worms 
that would open. It MAY support encryption/decryption in the future, but not 
with RSA.

%prep
%if %{defined git}
%autosetup -n php-jwt-%{git}
%else
gpgv2 --keyring %{SOURCE2} %{SOURCE1} %{SOURCE0}
%autosetup -n php-jwt-%{version}
%endif

%build
%{_bindir}/phpab -t fedora -o src/autoload.php src
cat <<'AUTOLOAD' | tee -a src/autoload.php
\Fedora\Autoloader\Dependencies::required(array(
    '%{_datadir}/php/ParagonIE/ConstantTime/autoload.php',
));
AUTOLOAD

%install
mkdir -p %{buildroot}%{_datadir}/php/fkooman/Jwt
cp -pr src/* %{buildroot}%{_datadir}/php/fkooman/Jwt

%check
%{_bindir}/phpab -o tests/autoload.php tests
cat <<'AUTOLOAD' | tee -a tests/autoload.php
require_once 'src/autoload.php';
AUTOLOAD

/usr/bin/phpunit8 tests --verbose --bootstrap=tests/autoload.php

%files
%license LICENSE
%doc composer.json CHANGES.md README.md
%dir %{_datadir}/php/fkooman
%{_datadir}/php/fkooman/Jwt

%changelog
* Tue Jul 09 2019 François Kooman <fkooman@tuxed.net> - 2.0.0-0.1
- update to 2.0.0

* Mon Mar 18 2019 François Kooman <fkooman@tuxed.net> - 1.0.0-2
- rebuilt

* Wed Mar 06 2019 François Kooman <fkooman@tuxed.net> - 1.0.0-1
- update to 1.0.0

* Fri Feb 08 2019 François Kooman <fkooman@tuxed.net> - 0.3.0-1
- update to 0.3.0

* Tue Oct 23 2018 François Kooman <fkooman@tuxed.net> - 0.2.2-1
- update to 0.2.2

* Tue Oct 23 2018 François Kooman <fkooman@tuxed.net> - 0.2.1-1
- update to 0.2.1

* Fri Sep 28 2018 François Kooman <fkooman@tuxed.net> - 0.1.0-2
- fix EL7 builds (autoloader syntax, missing R/BR)

* Fri Sep 28 2018 François Kooman <fkooman@tuxed.net> - 0.1.0-1
- initial package
